"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadConfig = void 0;
const store_1 = __importDefault(require("./store"));
const configs = {};
const uniqueKey = (stringArray) => {
    return stringArray.join("");
};
/**
 * load a configuration by passing composeOptions, and default options if desired
 *
 * @param composeOptions Confippet compose Options
 * @param defaults default config values
 * @param refresh should the config be refreshed
 * @returns returns config
 */
exports.loadConfig = (composeOptions, defaults, refresh) => {
    const cacheKey = uniqueKey(composeOptions.dirs);
    let config = configs[cacheKey];
    if (!config) {
        config = store_1.default();
    }
    if (refresh) {
        config._$.reset();
    }
    if (!configs[cacheKey] || refresh) {
        if (!refresh)
            config._cached = true; //this ok?
        config._$.defaults(defaults);
        config._$.compose(composeOptions);
        configs[cacheKey] = config;
    }
    return config;
};
//# sourceMappingURL=loadconfig.js.map