"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const _ = __importStar(require("lodash"));
const process_config_1 = __importDefault(require("./process-config"));
const compose_config_1 = __importDefault(require("./compose-config"));
const util_1 = __importDefault(require("./util"));
function hideProperties(obj, props) {
    props.forEach((prop) => {
        Object.defineProperty(obj, prop, {
            enumerable: false,
            writable: false,
            configurable: false
        });
    });
}
class Config {
    constructor(store) {
        this.store = store;
    }
    use(data) {
        util_1.default.merge(this.store, data);
    }
    defaults(data) {
        _.defaultsDeep(this.store, _.clone(data));
    }
    compose(info) {
        util_1.default.merge(this.store, compose_config_1.default(info));
    }
    process(options) {
        process_config_1.default(this.store, options);
    }
    reset() {
        const keys = Object.keys(this.store);
        keys.forEach((k) => {
            delete this.store[k];
        });
    }
}
function $get(p) {
    return _.get(this, p); // eslint-disable-line
}
function factory() {
    const store = {};
    store.$ = $get;
    store._$ = new Config(store);
    hideProperties(store, ["$", "_$"]);
    return store;
}
module.exports = factory;
//# sourceMappingURL=store.js.map